#!/usr/bin/perl
## ######### PROJECT NAME : ##########
## 
## raid_gui_glade.pm for  in /home/alex/PERL/raid_gui/CODE
## 
## ######### PROJECT DESCRIPTION : ###
## 
## This file is a part of the raid-gui perl program.
## 
## ###################################
## 
## Made by Boutonnet Alexandre
## Login   <alex@intellique.com>
## 
## Started on  Fri Jul 28 12:51:57 2006 Boutonnet Alexandre
## Last update Wed Feb 20 13:19:37 2008 Boutonnet Alexandre
## 
## ###################################
##

package raid_gui_glade;

use strict;
use warnings;

our $VERSION="1.0";

use Glib qw(TRUE FALSE);
use Gtk2::GladeXML;
use Gtk2 -init;
use Time::HiRes qw(gettimeofday tv_interval);

use Data::Dumper;

# use Gtk2::Ex::TreeMaker;

use raid;
use base 'Class::Accessor::Fast';

my $IMG_DIR = "/usr/share/icons/storiq/raid_gui/";
my $GLADE_DIR = "/usr/share/storiq/glade/";

__PACKAGE__->mk_accessors( qw(
			      raid_tree
			      vbox
			      alignement
			      window
			      treeview
			      bottom_img
			      bottom_text
			      button_refresh

			      window_verify
			      verify_rb_controler
			      verify_box_rb
			      verify_box_rb_2
			      verify_notebook
			      verify_alignement_rb
			      verify_alignement_rb_2

			      dialog_error
			      dialog_success
			      dialog_crash
			      dialog_error_text
			      dialog_success_text
			      dialog_crash_text

			      window_rescan
			      rescan_alignement_rb
			      rescan_box_rb

			      window_delete
			      delete_alignement_rb
			      delete_alignement_rb_2
			      delete_alignement_rb_3
			      delete_box_rb
			      delete_box_rb_2
			      delete_box_rb_3
			      delete_notebook

			      window_create
			      create_alignement_rb
			      create_alignement_rb_2
			      create_alignement_rb_3
			      create_box_rb
			      create_box_rb_2
			      create_box_rb_3
			      create_notebook

			      window_rebuild
			      rebuild_alignement_rb
			      rebuild_alignement_rb_2
			      rebuild_alignement_rb_3
			      rebuild_box_rb
			      rebuild_box_rb_2
			      rebuild_box_rb_3
			      rebuild_notebook

			      window_loading

			      button_create
			      button_delete
			      button_rebuild
			      button_rescan
			      button_rescan_appliquer
			      button_verify
			      button_refresh
			      button_verify_next
			      button_verify_appliquer
			      button_delete_next
			      button_delete_valider_unit
			      button_delete_valider_port
			      button_create_next
			      button_create_next_2
			      button_create_appliquer
			      button_rebuild_next
			      button_rebuild_appliquer

			      ));


# columns
use constant CONTROLER_COLUMN => 0;
use constant RAID_COLUMN      => 1;
use constant MODEL_COLUMN     => 2;
use constant STATUS_COLUMN    => 3;
use constant SIZE_COLUMN      => 4;
use constant HIDEN_COLUMN     => 5;

sub new
{
    return bless({}, shift);
}

sub init
{
    my $self = shift;

    $self->{struct} = shift;

    my $struct = $self->{struct};

    my $glade_file = $GLADE_DIR."raid_gui.glade";
    $struct->{GUI} = Gtk2::GladeXML->new($glade_file);
    $struct->{GUI}->signal_autoconnect_from_package($struct->{GLADE});

    # Gestion de toute les fenetres

    $self->window_verify($struct->{GUI}->get_widget('window_verify'));
    $self->dialog_error($struct->{GUI}->get_widget('dialog_error'));
    $self->dialog_success($struct->{GUI}->get_widget('dialog_success'));
    $self->dialog_crash($struct->{GUI}->get_widget('dialog_crash'));
    $self->window_rescan($struct->{GUI}->get_widget('window_rescan'));
    $self->window_delete($struct->{GUI}->get_widget('window_delete'));
    $self->window_create($struct->{GUI}->get_widget('window_create'));
    $self->window_rebuild($struct->{GUI}->get_widget('window_rebuild'));
    $self->window_loading($struct->{GUI}->get_widget('window_loading'));

    ## Fin gestion fenetres

    # Gestion des boutons, box, alignment etc..

    $self->raid_tree($struct->{GUI}->get_widget('raid_tree'));
    $self->alignement($struct->{GUI}->get_widget('alignement'));
    $self->window($struct->{GUI}->get_widget('window'));
    $self->treeview($struct->{GUI}->get_widget('treeview'));
    $self->bottom_img($struct->{GUI}->get_widget('bottom_img'));
    $self->bottom_text($struct->{GUI}->get_widget('bottom_text'));
    $self->verify_rb_controler($struct->{GUI}->get_widget('verify_rb_controler'));
    $self->verify_alignement_rb($struct->{GUI}->get_widget('verify_alignement_rb'));
    $self->verify_alignement_rb_2($struct->{GUI}->get_widget('verify_alignement_rb_2'));
    $self->verify_box_rb($struct->{GUI}->get_widget('verify_box_rb'));
    $self->verify_box_rb_2($struct->{GUI}->get_widget('verify_box_rb_2'));
    $self->verify_notebook($struct->{GUI}->get_widget('verify_notebook'));
    $self->dialog_error_text($struct->{GUI}->get_widget('dialog_error_text'));
    $self->dialog_success_text($struct->{GUI}->get_widget('dialog_success_text'));
    $self->dialog_crash_text($struct->{GUI}->get_widget('dialog_crash_text'));
    $self->rescan_alignement_rb($struct->{GUI}->get_widget('rescan_alignement_rb'));
    $self->rescan_box_rb($struct->{GUI}->get_widget('rescan_box_rb'));
    $self->delete_alignement_rb($struct->{GUI}->get_widget('delete_alignement_rb'));
    $self->delete_alignement_rb_2($struct->{GUI}->get_widget('delete_alignement_rb_2'));
    $self->delete_alignement_rb_3($struct->{GUI}->get_widget('delete_alignement_rb_3'));
    $self->delete_box_rb($struct->{GUI}->get_widget('delete_box_rb'));
    $self->delete_box_rb_2($struct->{GUI}->get_widget('delete_box_rb_2'));
    $self->delete_box_rb_3($struct->{GUI}->get_widget('delete_box_rb_3'));
    $self->delete_notebook($struct->{GUI}->get_widget('delete_notebook'));
    $self->create_alignement_rb($struct->{GUI}->get_widget('create_alignement_rb'));
    $self->create_alignement_rb_2($struct->{GUI}->get_widget('create_alignement_rb_2'));
    $self->create_alignement_rb_3($struct->{GUI}->get_widget('create_alignement_rb_3'));
    $self->create_box_rb($struct->{GUI}->get_widget('create_box_rb'));
    $self->create_box_rb_2($struct->{GUI}->get_widget('create_box_rb_2'));
    $self->create_box_rb_3($struct->{GUI}->get_widget('create_box_rb_3'));
    $self->create_notebook($struct->{GUI}->get_widget('create_notebook'));
    $self->rebuild_alignement_rb($struct->{GUI}->get_widget('rebuild_alignement_rb'));
    $self->rebuild_alignement_rb_2($struct->{GUI}->get_widget('rebuild_alignement_rb_2'));
    $self->rebuild_alignement_rb_3($struct->{GUI}->get_widget('rebuild_alignement_rb_3'));
    $self->rebuild_box_rb($struct->{GUI}->get_widget('rebuild_box_rb'));
    $self->rebuild_box_rb_2($struct->{GUI}->get_widget('rebuild_box_rb_2'));
    $self->rebuild_box_rb_3($struct->{GUI}->get_widget('rebuild_box_rb_3'));
    $self->rebuild_notebook($struct->{GUI}->get_widget('rebuild_notebook'));
    $self->button_delete($struct->{GUI}->get_widget('button_delete'));
    $self->button_create($struct->{GUI}->get_widget('button_create'));
    $self->button_rebuild($struct->{GUI}->get_widget('button_rebuild'));
    $self->button_rescan($struct->{GUI}->get_widget('button_rescan'));
    $self->button_verify($struct->{GUI}->get_widget('button_verify'));
    $self->button_refresh($struct->{GUI}->get_widget('button_refresh'));
    $self->button_rebuild_appliquer($struct->{GUI}->get_widget('button_rebuild_appliquer'));
    $self->button_delete_valider_unit($struct->{GUI}->get_widget('button_delete_valider_unit'));
    $self->button_delete_valider_port($struct->{GUI}->get_widget('button_delete_valider_port'));
    $self->button_create_next($struct->{GUI}->get_widget('button_create_next'));
    $self->button_verify_next($struct->{GUI}->get_widget('button_verify_next'));
    $self->button_rebuild_next($struct->{GUI}->get_widget('button_rebuild_next'));
    $self->button_rescan_appliquer($struct->{GUI}->get_widget('button_rescan_appliquer'));

    $self->window_loading->show;

    ## Fin de gestion du misc
}

sub on_window_delete_event
{
    Gtk2->main_quit;
}

###############################################################
#
# Creation et gestion de l'arbre principal.
#
###############################################################

sub make_tree
{
    my $self = shift;

    # affichage de la fenetre de chargement
    $self->window_loading->show;

    # create model
    my $model = _create_model($self);

    $self->treeview->set_model($model);

    $self->treeview->set_rules_hint(TRUE);
    $self->treeview->get_selection->set_mode ('multiple');
    
    _add_columns($self);

    # suppression de la fenetre
    $self->window_loading->hide;
}

sub refresh_tree
{
    my $self = shift;

    # affichage de la fenetre de chargement
    $self->window_loading->show;

    my $model = _create_model($self);

    $self->treeview->set_model($model);

    foreach (@{$self->{tab_path}})
    {
	$self->treeview->expand_to_path($_);
    }
    $self->bottom_text->set_text("");
    $self->bottom_img->set_from_file(undef);

    # suppression de la fenetre..
    $self->window_loading->hide;
}

sub _add_columns
{
    my $self = shift;

    my $treeview = $self->treeview;
    my $model = $treeview->get_model;
    my $selection = $treeview->get_selection;

    # column for the tree
    my $renderer = Gtk2::CellRendererText->new;
    $renderer->set (xalign => 0.0);

    my $col_offset = $treeview->insert_column_with_attributes 
	(-1, "Controler", $renderer);
#	 text => CONTROLER_COLUMN);
    my $column = $treeview->get_column ($col_offset - 1);
    $column->set_clickable (TRUE);

    my $cell_renderer = Gtk2::CellRendererPixbuf->new;
    $column->pack_start ($cell_renderer, FALSE);
    $column->set_cell_data_func ($cell_renderer, \&macro_set_func_pixbuf);

    $cell_renderer = Gtk2::CellRendererText->new;
    $column->pack_start ($cell_renderer, TRUE);
    $column->set_cell_data_func ($cell_renderer, \&macro_set_func_text);
    
    # raid column
    $renderer = Gtk2::CellRendererText->new;
    $renderer->set (xalign => 0.0);
    $col_offset = $treeview->insert_column_with_attributes 
	(-1, "Raid", $renderer,
	 text => RAID_COLUMN);
    $column = $treeview->get_column ($col_offset - 1);
    $column->set_clickable (TRUE);

    # Model column
    $renderer = Gtk2::CellRendererText->new;
    $renderer->set (xalign => 0.0);
    $col_offset = $treeview->insert_column_with_attributes 
	(-1, "Model", $renderer,
	 text => MODEL_COLUMN,
	 'foreground' => 6);
    $column = $treeview->get_column ($col_offset - 1);
    $column->set_clickable (TRUE);

    # Status column
    $renderer = Gtk2::CellRendererText->new;
    $renderer->set (xalign => 0.0);
    $col_offset = $treeview->insert_column_with_attributes 
	(-1, "Status", $renderer,
	 text => STATUS_COLUMN,
	 'foreground' => 6);
    $column = $treeview->get_column ($col_offset - 1);
    $column->set_clickable (TRUE);

    # Size column
    $renderer = Gtk2::CellRendererText->new;
    $renderer->set (xalign => 0.0);
    $col_offset = $treeview->insert_column_with_attributes 
	(-1, "Size", $renderer,
	 text => SIZE_COLUMN);
    $column = $treeview->get_column ($col_offset - 1);
    $column->set_clickable (TRUE);

    # Hiden column for unit ref
    $renderer = Gtk2::CellRendererText->new;
    $renderer->set (xalign => 0.0);
    $col_offset = $treeview->insert_column_with_attributes 
	(-1, "Unit-ref", $renderer,
	 text => HIDEN_COLUMN);
    $column = $treeview->get_column ($col_offset - 1);
    $column->set_clickable (TRUE);

    $column->set_visible (FALSE);

#    $treeview->expand_all;
    foreach (@{$self->{tab_path}})
    {
	$treeview->expand_to_path($_);
    }

    $selection->set_mode ('browse');
    $selection->signal_connect (changed => \&on_treeview_event, $self);
}

sub _create_model
{
    my $self = shift;

    my $model = Gtk2::TreeStore->new (qw/ Glib::Scalar
				      Glib::String 
				      Glib::String 
				      Glib::String 
				      Glib::String 
				      Glib::String 
				      Glib::String /);
    my $raid_hash = raid::info();
    $self->{raid_hash} = $raid_hash;

    _make_button_inactive($self);

    my $pixbuf;

    foreach my $key (sort keys(%{$raid_hash}))
    {
	my $model_name = $raid_hash->{$key}->{Model};
	my $opt = $raid_hash->{$key}->{NotOpt} ? "Not Optimal" : "Optimal";
	my $iter = $model->append (undef);
	my $info = {};
	$info->{icon} = Gtk2::Gdk::Pixbuf->new_from_file ($raid_hash->{$key}->{NotOpt} 
							  ? $IMG_DIR."raid_hw_fail.png" : $IMG_DIR."raid_hw.png");
	$info->{icon} = $info->{icon}->scale_simple (32, 32, 'bilinear');
	$info->{text} = $key eq "clo" ? "Software-RAID" : $key;

	push @{$self->{tab_path}}, $model->get_path($iter);

	# Test pour determiner si je mets la ligne en rouge
	if (!$raid_hash->{$key}->{NotOpt})
	{
	    $model->set ($iter,
			 CONTROLER_COLUMN, $info,
			 RAID_COLUMN,    FALSE,
			 MODEL_COLUMN,   $model_name,
			 STATUS_COLUMN,  $opt,
			 SIZE_COLUMN,     FALSE,
			 HIDEN_COLUMN,   $key);
	}
	else
	{
	    $model->set ($iter,
			 CONTROLER_COLUMN, $info,
			 RAID_COLUMN,    FALSE,
			 MODEL_COLUMN,   $model_name,
			 STATUS_COLUMN,  $opt,
			 SIZE_COLUMN,     FALSE,
			 HIDEN_COLUMN,   $key,
			 6, 'red');
	}

	foreach my $key_step1 (sort keys(%{$raid_hash->{$key}->{Unit}}))
	{
	    my $raid = $raid_hash->{$key}->{Unit}->{$key_step1}->{UnitType};
	    my $status = $raid_hash->{$key}->{Unit}->{$key_step1}->{Status};
	    my $size = $raid_hash->{$key}->{Unit}->{$key_step1}->{Size};

	    # Gestion du cas pourri ou les disques sont seuls ("-")
	    if ($key_step1 ne "-")
	    {
		my $info = {};
		
		my $raid_def = $raid_hash->{$key}->{'Unit'}->{$key_step1}->{'UnitType'};

		if (!defined($raid_def)) {
		    $raid_def = "unknown";
		}

		$raid_def =~ tr/A-Z/a-z/;

		if (!defined($raid_hash->{$key}->{'Unit'}->{$key_step1}->{'Status'})) {
		    $raid_hash->{$key}->{'Unit'}->{$key_step1}->{'Status'} = "UNKNOWN";
		}

		$info->{icon} = Gtk2::Gdk::Pixbuf->new_from_file (_return_good_png($raid_hash->{$key}->{'Unit'}->{$key_step1}->{'Status'} ne "OK" 
								  ? $IMG_DIR."raid_".$raid_def."_fail.png" : $IMG_DIR."raid_".$raid_def.".png"));
		$info->{icon} = $info->{icon}->scale_simple (32, 32, 'bilinear');
		$info->{text} = $key_step1;

		my $child_iter = $model->append ($iter);

		if (!defined($raid)) {
		    $raid = "";
		}
		if (!defined($status)) {
		    $status = "";
		}
		if (!defined($size)) {
		    $size = "";
		}


		$model->set ($child_iter,
			     CONTROLER_COLUMN, $info,
			     RAID_COLUMN, $raid,
			     MODEL_COLUMN, FALSE,
			     STATUS_COLUMN, $status,
			     SIZE_COLUMN, $size ne "" ? $size." Go" : $size,
			     HIDEN_COLUMN, $key.":".$key_step1);

		foreach my $key_step2 (@{$raid_hash->{$key}->{Unit}->{$key_step1}->{Port}})
		{
		    my $info = {};
		    $info->{icon} = Gtk2::Gdk::Pixbuf->new_from_file (_return_good_png($raid_hash->{$key}->{Drive}->{$key_step2}->{Status} ne "OK"
								       ? $IMG_DIR."raid_hdd_fail.png" : $IMG_DIR."raid_hdd.png"));
		    $info->{icon} = $info->{icon}->scale_simple (32, 32, 'bilinear');
		    $info->{text} = $key_step2;


		    $status = $raid_hash->{$key}->{Drive}->{$key_step2}->{Status};
		    $size = $raid_hash->{$key}->{Drive}->{$key_step2}->{Size};
		    $model_name = $raid_hash->{$key}->{Drive}->{$key_step2}->{Model};


		    my $child_iter_2 = $model->append ($child_iter);
		    $model->set ($child_iter_2,
				 CONTROLER_COLUMN, $info,
				 RAID_COLUMN, FALSE,
				 MODEL_COLUMN, $model_name,
				 STATUS_COLUMN, $status,
				 SIZE_COLUMN, $size." Go",
				 HIDEN_COLUMN, $key.":".$key_step1.":".$key_step2);
		}
	    }
	    else
	    {
		foreach my $key_step2 (@{$raid_hash->{$key}->{Unit}->{$key_step1}->{Port}})
		{
		    my $info = {};
		    $info->{icon} = Gtk2::Gdk::Pixbuf->new_from_file (_return_good_png($raid_hash->{$key}->{Drive}->{$key_step2}->{Status} ne "OK" 
								      ? $IMG_DIR."raid_hdd_fail.png" : $IMG_DIR."raid_hdd.png"));
		    $info->{icon} = $info->{icon}->scale_simple (32, 32, 'bilinear');
		    $info->{text} = $key_step2;


		    my $child_iter = $model->append ($iter);
		    $status = $raid_hash->{$key}->{Drive}->{$key_step2}->{Status};
		    $size = $raid_hash->{$key}->{Drive}->{$key_step2}->{Size};
		    $model_name = $raid_hash->{$key}->{Drive}->{$key_step2}->{Model};

		    $model->set ($child_iter,
				 CONTROLER_COLUMN, $info,
				 RAID_COLUMN, FALSE,
				 MODEL_COLUMN, $model_name,
				 STATUS_COLUMN, $status,
				 SIZE_COLUMN, $size." Go",
				 HIDEN_COLUMN, $key.":".$key_step1.":".$key_step2);
		}
	    }
 	}
    }

    return $model;
}

sub _make_button_inactive
{
    my $self = shift;

    # Je set tous mes boutons en actif...
    $self->button_create->set_sensitive(1);
    $self->button_delete->set_sensitive(1);
    $self->button_rebuild->set_sensitive(1);
    $self->button_rescan->set_sensitive(1);
    $self->button_verify->set_sensitive(1);

    if (!@{raid::list_port_creatable()})
    {
	$self->button_create->set_sensitive(0);
	$self->bottom_text->set_text("Unable to create new raid..");
    }
    
    # si ma hash de raid est undef, hop je desactive tout..
    if (!$self->{raid_hash})
    {
	$self->button_delete->set_sensitive(0);
	$self->button_rebuild->set_sensitive(0);
	$self->button_rescan->set_sensitive(0);
	$self->button_verify->set_sensitive(0);
	return;
    }

    my $flag = 0;
    my $flag_unit = 0;
    my $flag_lvm = 0;

    foreach my $key (sort keys(%{$self->{raid_hash}}))
    {
	# Si j'ai un lvm je saute le if suivant car je n'ai pas d'unite
	if ($key =~ m/lvm.*/)
	{
	    $flag_lvm = 1;
	    next;
	}
	# Je test si dans ma hash j'ai qq chose de different de clo et lvm
	if ($key ne "clo" || $key !~ m/lvm.*/)
	{
	    $flag = 1;
	}
	if ($self->{raid_hash}->{$key}->{'Units'} > 0)
	{
	    $flag_unit = 1;
	}
    }
    # s'il y a que le clo et lvm, je desactive ce qui est propre au carte controler
    if (!$flag)
    {
	$self->button_rebuild->set_sensitive(0);
	$self->button_rescan->set_sensitive(0);
	$self->button_verify->set_sensitive(0);
    }




    # S'il y a aucune unit dans aucun raid, je desactive delete, 
    # rebuild et verify.. Cf bug #113
    if (!$flag_unit)
    {
	# Si j'ai un lvm, je dois pouvoir faire un delete dessus, meme si j'ai pas d'unit
	if (!$flag_lvm)
	{
	    $self->button_delete->set_sensitive(0);	
	}
	$self->button_verify->set_sensitive(0);
	$self->button_rebuild->set_sensitive(0);
    }
}

sub on_treeview_event
{
  my ($selection, $self) = @_;

  # initialisation des variables 
  my $treeview = $self->treeview;
  my $model = $treeview->get_model;
  my $raid_hash = $self->{raid_hash};
  
  # je recup ma selection
  my $iter = $selection->get_selected;
  return unless defined $iter;

  # je recup la definition dans ma colone cachee
  my ($name) = $model->get ($iter, HIDEN_COLUMN);

  # je split ma definition
  my @ret_split = split(":", $name);
  my $num = scalar(@ret_split);

  # si le retour de split est 1, je gere une carte
  if ($num == 1)
  {
      $self->bottom_img->set_from_file(_return_good_png($raid_hash->{$ret_split[0]}->{NotOpt} 
				       ? $IMG_DIR."raid_hw_fail.png" : $IMG_DIR."raid_hw.png"));

      my $text = "";
      foreach my $key (keys(%{$raid_hash->{$ret_split[0]}}))
      {
	  if ($key ne "Unit" && $key ne "Drive")
	  {
	      $text = $text.$key." : ".$raid_hash->{$ret_split[0]}->{$key}."\n";
	  }
      }
      $self->bottom_text->set_text($text);
  }
  elsif ($num == 2)
  {
      if ($ret_split[1] eq "-")
      {
	  $self->bottom_img->set_from_file(_return_good_png($raid_hash->{$ret_split[0]}->{Drive}->{$ret_split[1]}->{Status} ne "OK" 
					   ? $IMG_DIR."raid_hdd_fail.png" : $IMG_DIR."raid_hdd.png"));
      }
      else
      {
	  my $raid_def = $raid_hash->{$ret_split[0]}->{'Unit'}->{$ret_split[1]}->{'UnitType'};

	  if (!defined($raid_def)) {
	      $raid_def = "unknown";
	  }

	  $raid_def =~ tr/A-Z/a-z/;

	  if (!defined($raid_hash->{$ret_split[0]}->{'Unit'}->{$ret_split[1]}->{'Status'})) {
	      $raid_hash->{$ret_split[0]}->{'Unit'}->{$ret_split[1]}->{'Status'} = "UNKNOWN";
	  }

	  $self->bottom_img->set_from_file(_return_good_png($raid_hash->{$ret_split[0]}->{'Unit'}->{$ret_split[1]}->{'Status'} ne "OK" 
					   ? $IMG_DIR."raid_".$raid_def."_fail.png" : $IMG_DIR."raid_".$raid_def.".png"));
      }

      my $text = "";
      foreach my $key (keys(%{$raid_hash->{$ret_split[0]}->{'Unit'}->{$ret_split[1]}}))
      {
 	  if ($key ne "Port")
 	  {
	      $text = $text.$key." : ".$raid_hash->{$ret_split[0]}->{'Unit'}->{$ret_split[1]}->{$key}."\n";
 	  }
	  else
	  {
	      my $port_list = $key." : ";
	      foreach my $port (@{$raid_hash->{$ret_split[0]}->{'Unit'}->{$ret_split[1]}->{$key}})
	      {
		  $port_list = $port_list.$port." ";
	      }
	      $text = $text.$port_list."\n";
	  }
      }
      $self->bottom_text->set_text($text);

  }
  elsif ($num == 3)
  {
      $self->bottom_img->set_from_file(_return_good_png($raid_hash->{$ret_split[0]}->{Drive}->{$ret_split[2]}->{Status} ne "OK" 
				       ? $IMG_DIR."raid_hdd_fail.png" : $IMG_DIR."raid_hdd.png"));

      my $text = "";
      foreach my $key (keys(%{$raid_hash->{$ret_split[0]}->{'Drive'}->{$ret_split[2]}}))
      {
	  $text = $text.$key." : ".$raid_hash->{$ret_split[0]}->{'Drive'}->{$ret_split[2]}->{$key}."\n";
      }
      $self->bottom_text->set_text($text);
  }
}

sub macro_set_func_text
{
    my ($tree_column, $cell, $model, $iter) = @_;
    my ($info) = $model->get ($iter, 0);
    $cell->set (text => $info->{text});
}

sub macro_set_func_pixbuf
{
    my ($tree_column, $cell, $model, $iter) = @_;
    my ($info) = $model->get ($iter, 0);
    $cell->set (pixbuf => $info->{icon});
}

# Cette methode permet de verifier la presence d'une image
# et au cas ou cette methode chie, retourner une image par defaut.
sub _return_good_png
{
    my $img = shift;
    
    if ( -f $img)
    {
	return $img;
    }
    else
    {
	if ($img =~ m/_fail/)
	{
	    return $IMG_DIR."raid_unknown_fail.png"
	}
	else
	{
	    return $IMG_DIR."raid_unknown.png"
	}
    }

    return $IMG_DIR."raid_unknown.png"
}

###############################################################
#
# Gestion de l'action verify.
#
###############################################################

sub on_button_verify_clicked
{
    my $self = shift;

    my $raid_hash = $self->{raid_hash};
    my $flag = 0;
    my $group;

    foreach my $key (sort keys(%{$raid_hash}))
    {
	if (!$flag)
	{
	    my  $button1 = Gtk2::RadioButton->new(undef, $key);
	    $self->verify_box_rb->pack_start($button1, FALSE, FALSE, 0);
	    $button1->show();
	    $group = $button1->get_group();
	    $self->{verify_rb} = $button1;
	    $flag = 1;
	}
	else
	{
	    my  $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $key);
	    $self->verify_box_rb->pack_start($button2, TRUE, TRUE, 0);
	    $button2->show();
	}
    }
    $self->window_verify->show;

}

sub on_button_verify_next_clicked
{
    my $self = shift;

    my $group = $self->{verify_rb}->get_group() ;

    my $but;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $self->{verify_rb_fst} = $but->get_label();
	}
    }
    $self->verify_notebook->set_current_page(1);

    my $flag = 0;

    foreach my $key (sort keys(%{$self->{raid_hash}->{$self->{verify_rb_fst}}->{Unit}}))
    {
	if ($key ne "-")
	{
	    if (!$flag)
	    {
		my  $button1 = Gtk2::RadioButton->new(undef, $key);
		$self->verify_box_rb_2->pack_start($button1, FALSE, FALSE, 0);
		$button1->show();
		$group = $button1->get_group();
		$self->{verify_rb_2} = $button1;
		$flag = 1;
	    }
	    else
	    {
		my  $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $key);
		$self->verify_box_rb_2->pack_start($button2, TRUE, TRUE, 0);
		$button2->show();
	    }
	}
    }

}

sub on_button_verify_annuler_clicked
{
    my $self = shift;

    $self->window_verify->hide();
    $self->verify_notebook->set_current_page(0);

    $self->verify_box_rb->destroy();
    $self->verify_box_rb->new(0, 0);
    $self->verify_alignement_rb->add($self->verify_box_rb);
    $self->verify_box_rb->show();

    $self->verify_box_rb_2->destroy();
    $self->verify_box_rb_2->new(0, 0);
    $self->verify_alignement_rb_2->add($self->verify_box_rb_2);
    $self->verify_box_rb_2->show();

    # Petit hack pour forcer le reaffichage du contenu
    # de ma fenetre en cas de delete pas le signal delete_event
    $self->button_verify_next->sensitive(1);
}

sub on_button_verify_appliquer_clicked
{
    my $self = shift;

    my  $group = $self->{verify_rb_2}->get_group() ;

    my $but;
    my $label;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $label = $but->get_label();
	}
    }

    # Je referme ma boite de dialogue
    on_button_verify_annuler_clicked($self);

    # J'appelle la gestion des messages d'erreur.
    aff_error($self, raid::verify($self->{verify_rb_fst} ,$label));
}

###############################################################
#
# Gestion de l'action rescan.
#
###############################################################

sub on_button_rescan_clicked
{
    my $self = shift;

    my $raid_hash = $self->{raid_hash};
    my $flag = 0;
    my $group;

    foreach my $key (sort keys(%{$raid_hash}))
    {
	if (!$flag)
	{
	    my  $button1 = Gtk2::RadioButton->new(undef, $key);
	    $self->rescan_box_rb->pack_start($button1, FALSE, FALSE, 0);
	    $button1->show();
	    $group = $button1->get_group();
	    $self->{rescan_rb} = $button1;
	    $flag = 1;
	}
	else
	{
	    my  $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $key);
	    $self->rescan_box_rb->pack_start($button2, TRUE, TRUE, 0);
	    $button2->show();
	}
    }
    $self->window_rescan->show;

}

sub on_button_rescan_appliquer_clicked
{
    my $self = shift;

    my  $group = $self->{rescan_rb}->get_group() ;

    my $but;
    my $label;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $label = $but->get_label();
	}
    }
    # Je referme ma boite de dialogue
    on_button_rescan_annuler_clicked($self);

    # J'appelle la gestion des messages d'erreur.
    aff_error($self, raid::rescan($label));

}

sub on_button_rescan_annuler_clicked
{
    my $self = shift;

    $self->window_rescan->hide();
#    $self->rescan_notebook->set_current_page(0);

    $self->rescan_box_rb->destroy();
    $self->rescan_box_rb->new(0, 0);
    $self->rescan_alignement_rb->add($self->rescan_box_rb);
    $self->rescan_box_rb->show();

    # Petit hack pour forcer le reaffichage du contenu
    # de ma fenetre en cas de delete pas le signal delete_event
    $self->button_rescan_appliquer->sensitive(1);
}

###############################################################
#
# Gestion de l'action delete.
#
###############################################################

sub on_button_delete_clicked
{
    my $self = shift;

    my $raid_hash = $self->{raid_hash};
    my $flag = 0;
    my $group;

    foreach my $key (sort keys(%{$raid_hash}))
    {
	if (!$flag)
	{
	    my  $button1 = Gtk2::RadioButton->new(undef, $key);
	    $self->delete_box_rb->pack_start($button1, FALSE, FALSE, 0);
	    $button1->show();
	    $group = $button1->get_group();
	    $self->{delete_rb} = $button1;
	    $flag = 1;
	}
	else
	{
	    my  $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $key);
	    $self->delete_box_rb->pack_start($button2, TRUE, TRUE, 0);
	    $button2->show();
	}
    }
    $self->window_delete->show;

}

sub on_button_delete_next_clicked
{
    my $self = shift;

    my $group = $self->{delete_rb}->get_group() ;

    my $but;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $self->{delete_rb_fst} = $but->get_label();
	}
    }
    $self->delete_notebook->set_current_page(1);

    my $flag = 0;

    foreach my $key (sort keys(%{$self->{raid_hash}->{$self->{delete_rb_fst}}->{Unit}}))
    {
	if ($key ne "-")
	{
	    if (!$flag)
	    {
		my  $button1 = Gtk2::RadioButton->new(undef, $key);
		$self->delete_box_rb_2->pack_start($button1, FALSE, FALSE, 0);
		$button1->show();
		$group = $button1->get_group();
		$self->{delete_rb_2} = $button1;
		$flag = 1;
	    }
	    else
	    {
		my  $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $key);
		$self->delete_box_rb_2->pack_start($button2, TRUE, TRUE, 0);
		$button2->show();
	    }
	}
    }
    # Si je ne suis pas passe dans ma boucle, je desactive le bouton
    if (!$flag)
    {
	$self->button_delete_valider_unit->set_sensitive(0);
    }

    $flag = 0;
    foreach my $key (sort keys(%{$self->{raid_hash}->{$self->{delete_rb_fst}}->{Drive}}))
    {
	if ($key ne "-")
	{
	    if (!$flag)
	    {
		my  $button1 = Gtk2::RadioButton->new(undef, $key);
		$self->delete_box_rb_3->pack_start($button1, FALSE, FALSE, 0);
		$button1->show();
		$group = $button1->get_group();
		$self->{delete_rb_3} = $button1;
		$flag = 1;
	    }
	    else
	    {
		my  $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $key);
		$self->delete_box_rb_3->pack_start($button2, TRUE, TRUE, 0);
		$button2->show();
	    }
	}
    }
    # Si je ne suis pas passe dans ma boucle, je desactive le bouton
    if (!$flag)
    {
	$self->button_delete_valider_port->set_sensitive(0);
    }
}

sub on_button_delete_annuler_clicked
{
    my $self = shift;

    $self->window_delete->hide();
    $self->delete_notebook->set_current_page(0);

    $self->delete_box_rb->destroy();
    $self->delete_box_rb->new(0, 0);
    $self->delete_alignement_rb->add($self->delete_box_rb);
    $self->delete_box_rb->show();

    $self->delete_box_rb_2->destroy();
    $self->delete_box_rb_2->new(0, 0);
    $self->delete_alignement_rb_2->add($self->delete_box_rb_2);
    $self->delete_box_rb_2->show();

    $self->delete_box_rb_3->destroy();
    $self->delete_box_rb_3->new(0, 0);
    $self->delete_alignement_rb_3->add($self->delete_box_rb_3);
    $self->delete_box_rb_3->show();

    $self->button_delete_valider_unit->sensitive(1);
    $self->button_delete_valider_port->sensitive(1);

}

sub on_button_delete_valider_unit_clicked
{
    my $self = shift;

    my  $group = $self->{delete_rb_2}->get_group() ;

    my $but;
    my $label;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $label = $but->get_label();
	}
    }

    # Je referme ma boite de dialogue
    on_button_delete_annuler_clicked($self);

    # J'appelle la gestion des messages d'erreur.
    aff_error($self, raid::deleteunit($self->{delete_rb_fst} ,$label));
}

sub on_button_delete_valider_port_clicked
{
    my $self = shift;

    my  $group = $self->{delete_rb_3}->get_group() ;

    my $but;
    my $label;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $label = $but->get_label();
	}
    }

    # Je referme ma boite de dialogue
    on_button_delete_annuler_clicked($self);

    # J'appelle la gestion des messages d'erreur.
    aff_error($self, raid::deleteport($self->{delete_rb_fst} ,$label));
}

###############################################################
#
# Gestion de l'action create.
#
###############################################################

sub on_button_create_clicked
{
    my $self = shift;

    my $port_creatable = raid::list_port_creatable();

    $self->{create_hash} = {};

    foreach (@{$port_creatable})
    {
	my @tab_tmp = split(" ", $_);
	if (!exists($self->{create_hash}->{$tab_tmp[0]}))
	{
	    $self->{create_hash}->{$tab_tmp[0]} = [];
	}
	push @{$self->{create_hash}->{$tab_tmp[0]}}, $tab_tmp[1];
    }

    my $flag = 0;
    my $group;

    foreach my $key (sort keys(%{$self->{create_hash}}))
    {
	if (!$flag)
	{
	    my  $button1 = Gtk2::RadioButton->new(undef, $key);
	    $self->create_box_rb->pack_start($button1, FALSE, FALSE, 0);
	    $button1->show();
	    $group = $button1->get_group();
	    $self->{create_rb} = $button1;
	    $flag = 1;
	}
	else
	{
	    my  $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $key);
	    $self->create_box_rb->pack_start($button2, TRUE, TRUE, 0);
	    $button2->show();
	}
    }
    $self->window_create->show;
}

sub on_button_create_next_clicked
{
    my $self = shift;

    my $group = $self->{create_rb}->get_group() ;

    my $but;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $self->{create_rb_fst} = $but->get_label();
	}
    }
    $self->create_notebook->set_current_page(1);

    $self->{create_cb} = {};

    foreach my $key (sort @{$self->{create_hash}->{$self->{create_rb_fst}}})
    {
	    $self->{create_cb}->{$key} = Gtk2::CheckButton->new($key);
	    $self->create_box_rb_2->pack_start($self->{create_cb}->{$key}, FALSE, FALSE, 0);
	    $self->{create_cb}->{$key}->show();
    }

}

sub on_button_create_next_2_clicked
{
    my $self = shift;

    # Je compte le nombre de port selectionne
    my $num_select = 0;
    
    foreach my $key (sort keys(%{$self->{create_cb}}))
    {
	if ($self->{create_cb}->{$key}->get_active())
	{
	    $num_select++;
	}
    }

    # Si l'user a selectionne aucune unit je reviens en arriere avec un
    # message d'erreur
    if (!$num_select || ($self->{create_rb_fst} eq "clo" && $num_select <= 1))
    {
	aff_error($self, (1, "You must choose almost one port\n"));
	$self->create_box_rb_2->destroy();
	$self->create_box_rb_2->new(0, 0);
	$self->create_alignement_rb_2->add($self->create_box_rb_2);
	$self->create_box_rb_2->show();
	on_button_create_next_clicked($self);
	return;
    }

    # Creation du tableau qui va contenir nos different type de raid
    my @raid_tab;

    if ($num_select >= 2)
    {
	push @raid_tab, "raid0";
    }
    
    if ($num_select == 2)
    {
	push @raid_tab, "raid1";
    }

    if ($num_select >= 3)
    {
	push @raid_tab, "raid5";
    }

    if ($num_select >= 4 && $self->{create_rb_fst} ne "clo")
    {
	push @raid_tab, "raid6";
    }

    if ($self->{create_rb_fst} ne "clo")
    {
	if ($num_select == 1)
	{
	    push @raid_tab, "single";
	    push @raid_tab, "jbod";
	    push @raid_tab, "spare";
	}
    }

    $self->create_notebook->set_current_page(2);

    my $flag = 0;
    my $group;
    foreach my $key (@raid_tab)
    {
	if (!$flag)
	{
	    my  $button1 = Gtk2::RadioButton->new(undef, $key);
	    $self->create_box_rb_3->pack_start($button1, FALSE, FALSE, 0);
	    $button1->show();
	    $group = $button1->get_group();
	    $self->{create_rb_3} = $button1;
	    $flag = 1;
	}
	else
	{
	    my  $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $key);
	    $self->create_box_rb_3->pack_start($button2, TRUE, TRUE, 0);
	    $button2->show();
	}
    }
    
}

sub on_button_create_annuler_clicked
{
    my $self = shift;

    $self->window_create->hide();
    $self->create_notebook->set_current_page(0);

    $self->create_box_rb->destroy();
    $self->create_box_rb->new(0, 0);
    $self->create_alignement_rb->add($self->create_box_rb);
    $self->create_box_rb->show();

    $self->create_box_rb_2->destroy();
    $self->create_box_rb_2->new(0, 0);
    $self->create_alignement_rb_2->add($self->create_box_rb_2);
    $self->create_box_rb_2->show();

    $self->create_box_rb_3->destroy();
    $self->create_box_rb_3->new(0, 0);
    $self->create_alignement_rb_3->add($self->create_box_rb_3);
    $self->create_box_rb_3->show();

    # Petit hack pour forcer le reaffichage du contenu
    # de ma fenetre en cas de delete pas le signal delete_event
    $self->button_create_next->sensitive(1);
}

sub on_button_create_appliquer_clicked
{
    my $self = shift;

    my  $group = $self->{create_rb_3}->get_group() ;

    my $but;
    my $label;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $label = $but->get_label();
	}
    }

    # Je referme ma boite de dialogue
    on_button_create_annuler_clicked($self);

    my @tab_port;
    foreach my $key (sort keys(%{$self->{create_cb}}))
    {
	if ($self->{create_cb}->{$key}->get_active())
	{
	    push @tab_port, $key;
	}
    }

    # J'appelle la gestion des messages d'erreur.
    aff_error($self, raid::createunit($self->{create_rb_fst} ,$label, @tab_port));
 }

###############################################################
#
# Gestion de l'action rebuild.
#
###############################################################

sub on_button_rebuild_clicked
{
    my $self = shift;

    my $unit_rebuildable = raid::list_unit_rebuildable();

    if (!defined $unit_rebuildable)
    {
	aff_error($self, (1, "No rebuildable unit !"));
	return;
    }

    my $flag = 0;
    my $group;

     foreach my $line (@{$unit_rebuildable})
     {
	if (!$flag)
	{
	    my  $button1 = Gtk2::RadioButton->new(undef, $line);
	    $self->rebuild_box_rb->pack_start($button1, FALSE, FALSE, 0);
	    $button1->show();
	    $group = $button1->get_group();
	    $self->{rebuild_rb} = $button1;
	    $flag = 1;
	}
	else
	{
	    my  $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $line);
	    $self->rebuild_box_rb->pack_start($button2, TRUE, TRUE, 0);
	    $button2->show();
	}
    }
    $self->window_rebuild->show;
}

sub on_button_rebuild_next_clicked
{
    my $self = shift;

    my $group = $self->{rebuild_rb}->get_group() ;

    my $but;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $self->{rebuild_rb_fst} = $but->get_label();
	}
    }
    $self->rebuild_notebook->set_current_page(1);

    my @tmp = split(" ", $self->{rebuild_rb_fst});

    my $controler = $tmp[0];

    my $port_rebuildable = raid::list_port_rebuildable();

    my $flag = 0;
    $group = 0;

    foreach my $line (@{$port_rebuildable})
    {
	if ($line =~ m/$controler .*/)
	{
	    $line = ($line =~ m/[.* ](.*)/)[0];

	    if (!$flag)
	    {
		my $button1 = Gtk2::RadioButton->new(undef, $line);
		$self->rebuild_box_rb_2->pack_start($button1, FALSE, FALSE, 0);
		$button1->show();
		$group = $button1->get_group();
		$self->{rebuild_rb_2} = $button1;
		$flag = 1;
	    }
	    else
	    {
		my $button2 = Gtk2::RadioButton->new_with_mnemonic($group, $line);
		$self->rebuild_box_rb_2->pack_start($button2, TRUE, TRUE, 0);
		$button2->show();
	    }
	}
    }
    if (!$flag)
    {
	$self->button_rebuild_appliquer->sensitive(0);
    }
}

sub on_button_rebuild_annuler_clicked
{
    my $self = shift;

    $self->window_rebuild->hide();
    $self->rebuild_notebook->set_current_page(0);

    $self->rebuild_box_rb->destroy();
    $self->rebuild_box_rb->new(0, 0);
    $self->rebuild_alignement_rb->add($self->rebuild_box_rb);
    $self->rebuild_box_rb->show();

    $self->rebuild_box_rb_2->destroy();
    $self->rebuild_box_rb_2->new(0, 0);
    $self->rebuild_alignement_rb_2->add($self->rebuild_box_rb_2);
    $self->rebuild_box_rb_2->show();

    # Petit hack pour forcer le reaffichage du contenu
    # de ma fenetre en cas de delete pas le signal delete_event
    $self->button_rebuild_appliquer->sensitive(1);
}

sub on_button_rebuild_appliquer_clicked
{
    my $self = shift;

    my  $group = $self->{rebuild_rb_2}->get_group() ;

    my $but;
    my $label;
    foreach $but (@$group)
    {
	if ($but->get_active)
	{
	    $label = $but->get_label();
	}
    }

    my @fst_arg = split(" ", $self->{rebuild_rb_fst});

    # Je referme ma boite de dialogue
    on_button_rebuild_annuler_clicked($self);

    # J'appelle la gestion des messages d'erreur.
    aff_error($self, raid::rebuild(@fst_arg, $label));
}


###############################################################
#
# Gestion des boites erreurs
#
###############################################################

sub aff_error
{
    my ($self, @data) = @_;

    # Je refresh mon tree pour appliquer les changements
    refresh_tree($self);

    if ($data[0] == 0)
    {
	$self->dialog_success_text->set_text($data[1]);
	$self->dialog_success->show();
    }
    elsif ($data[0] > 0)
    {
	$self->dialog_error_text->set_text($data[1]);
	$self->dialog_error->show();
    }
    elsif ($data[0] < 0)
    {
	$self->dialog_crash_text->set_text($data[1]);
	$self->dialog_crash->show();
    }
}

sub on_dialog_success_clicked
{
    my $self = shift;

    $self->dialog_success_text->set_text("");
    $self->dialog_success->hide();
}

sub on_dialog_error_clicked
{
    my $self = shift;

    $self->dialog_error_text->set_text("");
    $self->dialog_error->hide();
}

sub on_dialog_crash_clicked
{
    my $self = shift;

    $self->dialog_crash_text->set_text("");
    $self->dialog_crash->hide();
}

###############################################################
#
# Gestion des evenements a la con (busy mouse, bouton inactif)
#
###############################################################

# sub set_cursor_idle
# {
#     my $self = shift;

#     my $cursor = Gtk2::Gdk::Cursor->new('GDK_SB_H_DOUBLE_ARROW');
    
# #     $self->window->set_cursor(undef);
# #    $self->window->fullscreen;
# }

1;
